"use strict";
/**
 * @module document-key-prefixer
 */
Object.defineProperty(exports, "__esModule", { value: true });
var KEYS = ['id', 'rev'];
/* istanbul ignore next */
function toUnderscorePrefix(data) {
    if (!data)
        return data;
    if (Array.isArray(data)) {
        return data.map(item => toUnderscorePrefix(item));
    }
    if (data.results)
        return toUnderscorePrefix(data.results);
    if (data.docs)
        return toUnderscorePrefix(data.docs);
    var key;
    var value;
    const contentData = data;
    for (var i in KEYS) {
        key = KEYS[i];
        value = contentData[key];
        if (value) {
            if (!contentData['_' + key]) {
                contentData['_' + key] = value;
                delete contentData[key];
            }
        }
    }
    return data;
}
exports.toUnderscorePrefix = toUnderscorePrefix;
//# sourceMappingURL=to-underscore-prefix.js.map